#ifndef BUF_H
#define BUF_H

// come from xv6
#include "type.h"
#define BSIZE 1024
struct buf {
  int valid;   // has data been read from disk?
  int disk;    // does disk "own" buf?
  uint32_t dev;
  uint32_t blockno;
  uint32_t refcnt;
  struct buf *prev; // LRU cache list
  struct buf *next;
  unsigned char data[BSIZE];
};
#endif