#define MAP(x, f) f(x)
#define concat_temp(a, b) a ## b
#define concat(a, b) concat_temp(a, b)
#define REGS(f) \
    f(1) f(2) f(3) f(4) f(5) f(6) f(7) f(8) \
    f(9) f(10) f(11) f(12) f(13) f(14) f(15) f(16) \
    f(17) f(18) f(19) f(20) f(21) f(22) f(23) f(24) \
    f(25) f(26) f(27) f(28) f(29) f(30) f(31)

#define SAVE(n) sd concat(x, n), ((n-1)*8)(sp);
#define RESTORE(n) ld concat(x, n), ((n-1)*8)(sp);

#define REGS_NUM 31

.globl trap_handler
.globl trap_vector
.align 4
trap_vector:
    csrrw t0, sscratch, sp;
    addi sp, sp, -8 * REGS_NUM;
    MAP(SAVE, REGS);

    call trap_handler;

    MAP(RESTORE, REGS);
    addi sp, sp, 8 * REGS_NUM;
    csrrw sp, sscratch, t0;
    sret;
