#ifndef STDLIB_H
#define STDLIB_H

#include "type.h"
#include "stdbool.h"
#include "panic.h"

void *malloc(size_t size);
void free(void *ptr);

int atoi(const char *str);
long atol(const char *str);
long strtol(const char *nptr, char **endptr, int base);
unsigned long strtoul(const char *nptr, char **endptr, int base);

#endif