#include "include/sbi.h"
#include "include/printk.h"

void sbi_set_timer(uint64_t stime_value) {
    asm volatile("mv a0, %0" : : "r"(stime_value));
    asm volatile("li a7, 0");
    asm volatile("ecall");
}

void sbi_console_putchar(char ch) {
    asm volatile (
        "mv a0, %0\n"
        "li a7, 1\n"
        "ecall"
        :
        : "r"(ch)
        : "a0", "a7", "memory"
    );

}
